durationUnit
Description
Optional. Defines duration unit for tasksUsage
durationUnit:"hour" | "day";
Parameters
hour- sets the task duration to the hour unit, which allows users to select date and timeday(default) - the task duration will be measured in days
Example
<script>
import { getData } from "./common/data";
import { Gantt } from "@svar-ui/svelte-gantt";
const data = getData();
</script>
<Gantt {tasks} durationUnit="hour" />
info
durationUnit change requires data reload. When dynamically changing the durationUnit (e.g., from "hour" to "day"), users must also recalculate and reload task data (start, end, and duration) to ensure correct rendering.
Example:
<script>
import { getData } from "../data";
import { Gantt } from "@svar-ui/svelte-gantt";
import { RadioButtonGroup } from "@svar-ui/svelte-core";
let { tasks, links } = $state(getData());
const options = [
{ id: "hour", label: "Hour" },
{ id: "day", label: "Day" },
];
let durationUnit = $state("hour");
let api = $state();
function handleUnitChange({ value }) {
// here we use api.serialize() to get serialized tasks
const sTasks = api.serialize().map(task => {
// and than we recalculate task duration
if (task.start && task.end) {
const ms = 1000 * 60 * 60 * (value === "day" ? 24 : 1);
const duration = Math.floor((task.end - task.start) / ms);
return { ...task, duration };
}
return task;
});
tasks = sTasks;
durationUnit = value;
}
</script>
<div>
<RadioButtonGroup
{options}
value={durationUnit}
type="inline"
onchange={handleUnitChange}
/>
<Gantt
bind:this={api}
{tasks}
{links}
{durationUnit}
/>
</div>

durationUnit
Description
Optional. Defines duration unit for tasksUsage
durationUnit: "hour" | "day";
Parameters
hour- sets the task duration to the hour unit, which allows users to select date and timeday(default) - the task duration will be measured in days
Example
<script setup>
import { getData } from "./common/data";
import { Gantt } from "@svar-ui/vue-gantt";
const data = getData();
</script>
<template>
<Gantt :tasks="tasks" durationUnit="hour" />
</template>
info
durationUnit change requires data reload. When dynamically changing the durationUnit (e.g., from "hour" to "day"), users must also recalculate and reload task data (start, end, and duration) to ensure correct rendering.
Example:
<script setup>
import { getData } from "../data";
import { Gantt } from "@svar-ui/vue-gantt";
import { RadioButtonGroup } from "@svar-ui/vue-core";
import { ref } from "vue";
const { tasks: initialTasks, links: initialLinks } = getData();
const tasks = ref(initialTasks);
const links = ref(initialLinks);
const options = [
{ id: "hour", label: "Hour" },
{ id: "day", label: "Day" },
];
const durationUnit = ref("hour");
const api = ref();
function handleUnitChange({ value }) {
// here we use api.serialize() to get serialized tasks
const sTasks = api.value.serialize().map(task => {
// and than we recalculate task duration
if (task.start && task.end) {
const ms = 1000 * 60 * 60 * (value === "day" ? 24 : 1);
const duration = Math.floor((task.end - task.start) / ms);
return { ...task, duration };
}
return task;
});
tasks.value = sTasks;
durationUnit.value = value;
}
</script>
<template>
<div>
<RadioButtonGroup
:options="options"
:value="durationUnit"
type="inline"
:onchange="handleUnitChange"
/>
<Gantt
ref="api"
:tasks="tasks"
:links="links"
:durationUnit="durationUnit"
/>
</div>
</template>
Related samples:
Related article:

durationUnit
Description
Optional. Defines duration unit for tasksUsage
durationUnit: "hour" | "day";
Parameters
hour- sets the task duration to the hour unit, which allows users to select date and timeday(default) - the task duration will be measured in days
Example
import { getData } from "./common/data";
import { Gantt } from "@svar-ui/react-gantt";
const data = getData();
function App() {
return <Gantt tasks={data.tasks} durationUnit="hour" />;
}
export default App;
info
durationUnit change requires data reload. When dynamically changing the durationUnit (e.g., from "hour" to "day"), users must also recalculate and reload task data (start, end, and duration) to ensure correct rendering.
Example:
import { useState } from "react";
import { getData } from "../data";
import { Gantt } from "@svar-ui/react-gantt";
import { RadioButtonGroup } from "@svar-ui/react-core";
function App() {
const [data, setData] = useState(getData());
const [durationUnit, setDurationUnit] = useState("hour");
const [api, setApi] = useState(null);
const options = [
{ id: "hour", label: "Hour" },
{ id: "day", label: "Day" },
];
function handleUnitChange({ value }) {
// here we use api.serialize() to get serialized tasks
const sTasks = api.serialize().map(task => {
// and then we recalculate task duration
if (task.start && task.end) {
const ms = 1000 * 60 * 60 * (value === "day" ? 24 : 1);
const duration = Math.floor((task.end - task.start) / ms);
return { ...task, duration };
}
return task;
});
setData({ ...data, tasks: sTasks });
setDurationUnit(value);
}
return (
<div>
<RadioButtonGroup
options={options}
value={durationUnit}
type="inline"
onChange={handleUnitChange}
/>
<Gantt
init={setApi}
tasks={data.tasks}
links={data.links}
durationUnit={durationUnit}
/>
</div>
);
}
export default App;
Related samples: